searchData={"items":[{"type":"module","title":"AshCanonicalIdentity","doc":"","ref":"AshCanonicalIdentity.html"},{"type":"macro","title":"AshCanonicalIdentity.canonical_identities/1","doc":"","ref":"AshCanonicalIdentity.html#canonical_identities/1"},{"type":"module","title":"AshCanonicalIdentity.Identity","doc":"","ref":"AshCanonicalIdentity.Identity.html"},{"type":"module","title":"AshCanonicalIdentity.Info","doc":"","ref":"AshCanonicalIdentity.Info.html"},{"type":"function","title":"AshCanonicalIdentity.Info.canonical_identities/1","doc":"canonical_identities DSL entities","ref":"AshCanonicalIdentity.Info.html#canonical_identities/1"},{"type":"module","title":"AshCanonicalIdentity.Transformer","doc":"","ref":"AshCanonicalIdentity.Transformer.html"},{"type":"function","title":"AshCanonicalIdentity.Transformer.after?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","ref":"AshCanonicalIdentity.Transformer.html#after?/1"},{"type":"function","title":"AshCanonicalIdentity.Transformer.after_compile?/0","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshCanonicalIdentity.Transformer.html#after_compile?/0"},{"type":"function","title":"AshCanonicalIdentity.Transformer.before?/1","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","ref":"AshCanonicalIdentity.Transformer.html#before?/1"},{"type":"function","title":"AshCanonicalIdentity.Transformer.transform/1","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","ref":"AshCanonicalIdentity.Transformer.html#transform/1"},{"type":"extras","title":"AshCanonicalIdentity","doc":"# AshCanonicalIdentity\n\nGenerate identity, get_by action and code_interface for unique keys.","ref":"readme.html"},{"type":"extras","title":"Installation - AshCanonicalIdentity","doc":"Add `ash_canonical_identity` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_canonical_identity, \"~> 0.1.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshCanonicalIdentity","doc":"```elixir\ndefmodule Post do\n  use Ash.Resource,\n    data_layer: Ash.DataLayer.Postgres,\n    extensions: [AshCanonicalIdentity]\n\n\n  attributes do\n    uuid_primary_key :id\n\n    attribute :title, :string, allow_nil?: false, public?: true\n  end\n\n  actions do\n    defaults [:read, :destroy, create: :*, update: :*]\n  end\nend\n\ndefmodule PostTag do\n  use Ash.Resource,\n    data_layer: Ash.DataLayer.Postgres,\n    extensions: [AshCanonicalIdentity]\n\n\n  attributes do\n    uuid_primary_key :id\n\n    attribute :tag, :string, allow_nil?: true, public?: true\n  end\n\n  actions do\n    defaults [:read, :destroy, create: :*, update: :*]\n  end\n\n  relationships do\n    belongs_to :post, Post, allow_nil?: false, public?: true\n  end\n\n  canonical_identities do\n    identity [:post, :tag]\n  end\nend\n```\n\nThe `identity [:post, :tag]` set in `canonical_identities` above has the same effect as the code below:\n\n```elixir\nidentities do\n  identity :post_tag, [:post_id, :tag]\nend\n\nactions do\n  read :get_by_post_tag do\n    get? true\n    argument :post_id, :uuid, allow_nil?: false\n    argument :tag, :string, allow_nil?: false\n    filter expr(post_id == ^arg(:post_id))\n    filter expr(tag == ^arg(:tag))\n  end\nend\n\ncode_interface do\n  define :get_by_post_tag, args: [:post_id, :tag]\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"License - AshCanonicalIdentity","doc":"MIT","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}